#!/bin/bash
#

#
#анализ ответа по HTTP
#

_file_res_def="/home/httpd/ramdisk/anshttp.dat"
_file_res=""
_flle_on=""

vversion="01.01"
vdate="26.11.2017"
_sans=""
_anscode=""
_Date=""
_Content_Type=""
_Content_Length=""
_Location=""
_P3P=""
_Server=""
_Last_Modified=""
_ETag=""
_Accept_Ranges=""
_X_Powered_By=""
_X_XSS_Protection=""
_X_Content_Type_Options=""
_Set_Cookie=""
_Vary=""
_Cache_Control=""
_Referrer_Policy=""
_Proxy_Authenticate=""
_Proxy_Connection=""
_Allow=""

_str=""

#подсказка
function _help()
{
	echo -e ""
	echo -e "****** \tanshttp.sh Date:$vdate Version:$vversion - анализ ответа по HTTP ******"
	echo -e "tanshttp.sh -a <data>      - анализ строки <data>"
	echo -e "tanshttp.sh -at <data>     - анализ строки <data> с выводом в консоль"
	echo -e "tanshttp.sh -af <data>     - анализ строки <data> с выводом в файл \"/home/httpd/ramdisk/anshttp.dat\""
	echo -e "tanshttp.sh -afc <data>    - анализ строки <data> с выводом в файл \"/home/httpd/ramdisk/anshttp.dat\""
	echo -e "                             с анализом кода ответа"
	echo -e ""
}

function _file()
{
	echo -e "" > "$_file_res"
	echo -e "Status-Code: $_anscode :$_str" >> "$_file_res"
	echo -e "Content-Type: $_Content_Type" >> "$_file_res"
	echo -e "Date: $_Date" >> "$_file_res"
	echo -e "Content-Length: $_Content_Length" >> "$_file_res"
	echo -e "Location: $_Location" >> "$_file_res"
	echo -e "P3P: $_P3P" >> "$_file_res"
	echo -e "Server: $_Server" >> "$_file_res"
	echo -e "Last-Modified: $_Last_Modified" >> "$_file_res"
	echo -e "ETag: $_ETag" >> "$_file_res"
	echo -e "Accept-Ranges: $_Accept_Ranges" >> "$_file_res"
	echo -e "X-Powered-By: $_X_Powered_By" >> "$_file_res"
	echo -e "X-XSS-Protection: $_X_XSS_Protection" >> "$_file_res"
	echo -e "X-Content-Type-Options: $_X_Content_Type_Options" >> "$_file_res"
	echo -e "Set-Cookie: $_Set_Cookie" >> "$_file_res"
	echo -e "Vary: $_Vary" >> "$_file_res"
	echo -e "Cache-Control: $_Cache_Control" >> "$_file_res"
	echo -e "Referrer-Policy: $_Referrer_Policy" >> "$_file_res"
	echo -e "Proxy-Authenticate: $_Proxy_Authenticate" >> "$_file_res"
	echo -e "Proxy-Connection: $_Proxy_Connection" >> "$_file_res"
	echo -e "Allow: $_Allow" >> "$_file_res"
}

function _anscode_com()
{
	case $_anscode in
		"100")
			_str="Продолжать, Continue"
		;;
		"101")
			_str="Переключение протоколов, Switching Protocols"
		;;
		"200")
			_str="Ok"
		;;
		"201")
			_str="Создан, Created"
		;;
		"202")
			_str="Принято, Accepted"
		;;
		"203")
			_str="Не авторская информация, Non-Authoritative Information"
		;;
		"204")
			_str="Нет содержимого, No Content"
		;;
		"205")
			_str="Сбросить содержимое, Reset Content"
		;;
		"206")
			_str="Частичное содержимое, Partial Content"
		;;
		"301")
			_str="Постоянно перенесен, Moved Permanently."
		;;
		"302")
			_str="Временно перемещен, Moved Temporarily."
		;;
		"303")
			_str="Смотреть другой, See Other"
		;;
		"304")
			_str="Не модифицирован, Not Modified"
		;;
		"305")
			_str="Используйте прокси-сервер, Use Proxy"
		;;
		"307")
			_str="Временное перенаправление, Temporary Redirect"
		;;
		"308")
			_str="Постоянное перенаправление, Permanent Redirect"
		;;
		"400")
			_str="(Ошибка клиента - запроса) Испорченный Запрос, Bad Request."
		;;
		"401")
			_str="(Ошибка клиента - запроса) Несанкционированно, Unauthorized"
		;;
		"402")
			_str="(Ошибка клиента - запроса) Требуется оплата, Payment Required"
		;;
		"403")
			_str="(Ошибка клиента - запроса) Запрещено, Forbidden"
		;;
		"404")
			_str="(Ошибка клиента - запроса) Не найден, Not Found."
		;;
		"405")
			_str="(Ошибка клиента - запроса) Метод не дозволен, Method Not Allowed"
		;;
		"406")
			_str="(Ошибка клиента - запроса) Не приемлем, Not Acceptable"
		;;
		"407")
			_str="(Ошибка клиента - запроса) Требуется установление подлинности через прокси-сервер, Proxy Authentication Required"
		;;
		"408")
			_str="(Ошибка клиента - запроса) Истекло время ожидания запроса, Request Timeout"
		;;
		"409")
			_str="(Ошибка клиента - запроса) Конфликт, Conflict."
		;;
		"410")
			_str="(Ошибка клиента - запроса) Удален, Gone."
		;;
		"411")
			_str="(Ошибка клиента - запроса) Требуется длина, Length Required."
		;;
		"412")
			_str="(Ошибка клиента - запроса) Предусловие неверно, Precondition Failed."
		;;
		"413")
			_str="(Ошибка клиента - запроса) Объект запроса слишком большой, Request Entity Too Large."
		;;
		"414")
			_str="(Ошибка клиента - запроса) запроса слишком длинный, Request-URI Too Long."
		;;
		"415")
			_str="(Ошибка клиента - запроса) Неподдерживаемый медиа тип, Unsupported Media Type."
		;;
		"500")
			_str="(Ошибка сервера) Внутренняя ошибка сервера, Internal Server Error."
		;;
		"501")
			_str="(Ошибка сервера) Не реализовано, Not Implemented."
		;;
		"502")
			_str="(Ошибка сервера) Ошибка шлюза, Bad Gateway."
		;;
		"503")
			_str="(Ошибка сервера) Сервис недоступен, Service Unavailable."
		;;
		"504")
			_str="(Ошибка сервера) Истекло время ожидания от шлюза, Gateway Timeout."
		;;
		"505")
			_str="(Ошибка сервера) Не поддерживаемая версия HTTP, HTTP Version Not Supported."
		;;
		*)
			_str="Тип ответа не определён"
		;;
	esac
}

#анализ
function _ahttp()
{
	echo "$_sans"
	if [ "$_anscode" == "" ]; then
	 _anscode=$(echo -e "$_sans" | awk '/HTTP\// {print($2)}') 
	fi
	if [ "$_Content_Type" == "" ]; then
	 _Content_Type=$(echo -e "$_sans" | grep "Content-Type:" | sed 's/Content-Type: //g')
	fi
	_Date=$(echo -e "$_sans" | grep "Date:" | sed 's/Date: //g')
	_Content_Length=$(echo -e "$_sans" | grep "Content-Length:" | sed 's/Content-Length: //g')
	_Location=$(echo -e "$_sans" | grep "Location:" | sed 's/Location: //g')
	_P3P=$(echo -e "$_sans" | grep "P3P:" | sed 's/P3P: //g')
	_Server=$(echo -e "$_sans" | grep "Server:" | sed 's/Server: //g')
	_Last_Modified=$(echo -e "$_sans" | grep "Last-Modified:" | sed 's/Last-Modified: //g')
	_ETag=$(echo -e "$_sans" | grep "ETag:" | sed 's/ETag: //g')
	_Accept_Ranges=$(echo -e "$_sans" | grep "Accept-Ranges:" | sed 's/Accept-Ranges: //g')
	_X_Powered_By=$(echo -e "$_sans" | grep "X-Powered-By:" | sed 's/X-Powered-By: //g')
	_X_XSS_Protection=$(echo -e "$_sans" | grep "X-XSS-Protection:" | sed 's/X-XSS-Protection: //g')
	_X_Content_Type_Options=$(echo -e "$_sans" | grep "X-Content-Type-Options:" | sed 's/X-Content-Type-Options: //g')
	_Set_Cookie=$(echo -e "$_sans" | grep "Set-Cookie:" | sed 's/Set-Cookie: //g')
	_Vary=$(echo -e "$_sans" | grep "Vary:" | sed 's/Vary: //g')
	_Cache_Control=$(echo -e "$_sans" | grep "Cache-Control:" | sed 's/Cache-Control: //g')
	_Referrer_Policy=$(echo -e "$_sans" | grep "Referrer-Policy:" | sed 's/Referrer-Policy: //g')
	_Proxy_Authenticate=$(echo -e "$_sans" | grep "Proxy-Authenticate:" | sed 's/Proxy-Authenticate: //g')
	_Proxy_Connection=$(echo -e "$_sans" | grep "Proxy-Connection:" | sed 's/Proxy-Connection: //g')
	_Allow=$(echo -e "$_sans" | grep "Allow:" | sed 's/Allow: //g')
}

function _athttp()
{
	_ahttp
	_anscode_com
	echo "***************** Ответ на запрос ******************************"
	if [ "$_anscode" != "" ]; then
	echo -e "Результат\t\t: $_anscode - $_str"
	fi
	if [ "$_Cache_Control" != "" ]; then
	echo -e "Cache-Control\t\t: $_Cache_Control"
	fi
	if [ "$_Referrer_Policy" != "" ]; then
	echo -e "Referrer-Policy\t\t: $_Referrer_Policy"
	fi
	if [ "$_Date" != "" ]; then
	echo -e "Date\t\t\t: $_Date"
	fi
	if [ "$_Location" != "" ]; then
	echo -e "Location\t\t: $_Location"
	fi
	if [ "$_P3P" != "" ]; then
	echo -e "P3P\t\t\t: $_P3P"
	fi
	if [ "$_Server" != "" ]; then
	echo -e "Server\t\t\t: $_Server"
	fi
	if [ "$_Last_Modified" != "" ]; then
	echo -e "Last-Modified\t\t: $_Last_Modified"
	fi
	if [ "$_ETag" != "" ]; then
	echo -e "ETag\t\t\t: $_ETag"
	fi
	if [ "$_X_Powered_By" != "" ]; then
	echo -e "X-Powered-By\t: $_X_Powered_By"
	fi
	if [ "$_X_XSS_Protection" != "" ]; then
	echo -e "X-XSS-Protection\t: $_X_XSS_Protection"
	fi
	if [ "$_X_Content_Type_Options" != "" ]; then
	echo -e "X-Content-Type-Options\t: $_X_Content_Type_Options"
	fi
	if [ "$_Set_Cookie" != "" ]; then
	echo -e "Set-Cookie\t\t: $_Set_Cookie"
	fi
	if [ "$_Accept_Ranges" != "" ]; then
	echo -e "Accept-Ranges\t\t: $_Accept_Ranges"
	fi
	if [ "$_Allow" != "" ]; then
	echo -e "Allow\t\t\t: $_Allow"
	fi
	if [ "$_Content_Length" != "" ]; then
	echo -e "Content-Length\t\t: $_Content_Length"
	fi
	if [ "$_Vary" != "" ]; then
	echo -e "Vary\t\t\t: $_Vary"
	fi
	if [ "$_Content_Type" != "" ]; then
	echo -e "Content-Type\t\t: $_Content_Type"
	fi
	if [ "$_Proxy_Authenticate" != "" ]; then
	echo -e "Proxy-Authenticate\t: $_Proxy_Authenticate"
	fi
	if [ "$_Proxy_Connection" != "" ]; then
	echo -e "Proxy-Connection\t: $_Proxy_Connection"
	fi
	echo "****************************************************************"
}

case $1 in
	"help")
		_help
	;;
	"-a")
		_sans=$2
		_ahttp
	;;
	"-at")
		_sans=$2
		_anscode_com
		_athttp
	;;
	"-af")
		_sans=$2
		_file_res=$_file_res_def
		echo "CMD File:$_file_on  File:$_file_res"
		_ahttp
		_file
	;;
	"-afc")
		_sans=$2
		_file_res=$_file_res_def
		echo "CMD File:$_file_on  File:$_file_res"
		_ahttp
		_anscode_com
		_file
	;;
	*)
		echo -e ""
		echo -e "примените \"help\" для информации"
		echo -e ""
	;;
esac
  
